Imports System.Linq
Imports System.Text
Imports System.Threading.Tasks
Imports Windows.Phone.Management.Deployment
Imports Windows.ApplicationModel
Imports CompanyHub.Utilities
Imports System
Imports System.Collections
Imports System.Collections.Generic

Namespace CompanyHub.Models
    Public Enum CompanyPackageStatus
        Unknown
        [New]
        Update
        Installed
    End Enum

    Public Class CompanyPackage
        Public Property Id As String

        Public Property Name As String

        Public Property Description As String

        Public Property Thumbnail As String

        Public Property Version As String

        Public Property SourceUri As Uri

        Public Property Status As CompanyPackageStatus

        Public Shared Function GenerateData() As IEnumerable(Of CompanyPackage)
            Dim data = New List(Of CompanyPackage)

            ' Get list of installed apps
            Dim pkgs = InstallationManager.FindPackagesForCurrentPublisher

            For Each pkg In pkgs
                ' Don't add hub app to the list
                If pkg.Id.Name <> "CompanyHub" Then
                    ' Create new CompanyPackage obj using info from Id

                    Dim compPkg = New CompanyPackage With {.Id = pkg.Id.ProductId, .Name = pkg.Id.Name, .Description = "Test Description", .Version = PackageVersionHelper.VersionToString(pkg.Id.Version), .Thumbnail = "/Assets/ApplicationIcon.png", .Status = CompanyPackageStatus.Unknown}

                    ' Create some updatable versions
                    If data.Count > 3 Then
                        compPkg.Version = "2.0.0.0"
                    End If

                    data.Add(compPkg)
                End If
            Next pkg

            ' Add three new products
            For i  = 7 To 9
                Dim compPkg = New CompanyPackage With {.Id = Guid.NewGuid.ToString, .Name = "CDS APP " & i, .Description = "Test Description", .Version = "1.0.0.0", .Thumbnail = "/Assets/ApplicationIcon.png", .Status = CompanyPackageStatus.Unknown}

                data.Add(compPkg)
            Next i

            Return data
        End Function
    End Class
End Namespace
