Imports System.Linq
Imports System.Net
Imports System.Windows
Imports System.Windows.Controls
Imports System.Windows.Navigation
Imports Microsoft.Phone.Controls
Imports Microsoft.Phone.Shell
Imports CompanyHub.Models
Imports Windows.ApplicationModel
Imports Windows.Phone.Management.Deployment
Imports System

Namespace CompanyHub
	Partial Public Class PackagePage
		Inherits PhoneApplicationPage

		Public Sub New()
			InitializeComponent()
		End Sub

		Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
			MyBase.OnNavigatedTo(e)

			Dim id As String = ""

			If NavigationContext.QueryString.TryGetValue("id", id) Then
				DataContext = App.ViewModel.FindPackage(id)
				UpdateUI()
			End If
		End Sub

		Private Sub UpdateUI()
			Dim pkg = TryCast(DataContext, CompanyPackage)

			Select Case pkg.Status
				Case CompanyPackageStatus.Installed
					btnInstall.Visibility = System.Windows.Visibility.Collapsed
				Case CompanyPackageStatus.New
					btnLaunch.Visibility = System.Windows.Visibility.Collapsed
				Case CompanyPackageStatus.Update
					btnInstall.Content = "Update"
			End Select
		End Sub

Private async Sub btnInstall_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
	Dim pkg = TryCast(DataContext, CompanyPackage)
	If MessageBox.Show("Install " & pkg.Name & "?", "Install app", MessageBoxButton.OKCancel) = MessageBoxResult.OK Then
		Try
			Dim result = await InstallationManager.AddPackageAsync(pkg.Name, pkg.SourceUri)
			If result.InstallState = Windows.Management.Deployment.PackageInstallState.Installed Then
				MessageBox.Show(pkg.Name & " was installed.")
				App.ViewModel.UpdatePackageStatus()
				UpdateUI()
			Else
				MessageBox.Show("An error occurred during installation.")
			End If
                Catch e1 As System.Exception
                    MessageBox.Show("An error occurred during installation.")
		End Try
	End If
End Sub

Private Sub btnLaunch_Click(ByVal sender As Object, ByVal e As RoutedEventArgs)
	Dim pkg = TryCast(DataContext, CompanyPackage)

	Dim devicePkgs = InstallationManager.FindPackagesForCurrentPublisher

	Dim devicePkg = devicePkgs.Where(Function(p) p.Id.ProductId = pkg.Id).FirstOrDefault

	If devicePkg IsNot Nothing Then
		devicePkg.Launch("")
	End If
End Sub
	End Class
End Namespace
